import { AccordionPanel, Title, Widget } from '@lumino/widgets';
/**
 * RTC accordion panel customization
 */
export declare namespace RTCPanel {
    /**
     * Custom renderer for the RTC sidebar
     */
    class Renderer extends AccordionPanel.Renderer {
        /**
         * Render the collapse indicator for a section title.
         *
         * @param data - The data to use for rendering the section title.
         *
         * @returns A element representing the collapse indicator.
         */
        createCollapseIcon(data: Title<Widget>): HTMLElement;
        /**
         * Render the element for a section title.
         *
         * @param data - The data to use for rendering the section title.
         *
         * @returns A element representing the section title.
         */
        createSectionTitle(data: Title<Widget>): HTMLElement;
    }
}
