// Copyright (c) Jupyter Development Team.
// Distributed under the terms of the Modified BSD License.
import { caretDownIcon } from '@jupyterlab/ui-components';
import { AccordionPanel } from '@lumino/widgets';
/**
 * RTC accordion panel customization
 */
export var RTCPanel;
(function (RTCPanel) {
    /**
     * Custom renderer for the RTC sidebar
     */
    class Renderer extends AccordionPanel.Renderer {
        /**
         * Render the collapse indicator for a section title.
         *
         * @param data - The data to use for rendering the section title.
         *
         * @returns A element representing the collapse indicator.
         */
        createCollapseIcon(data) {
            const iconDiv = document.createElement('div');
            caretDownIcon.element({
                container: iconDiv
            });
            return iconDiv;
        }
        /**
         * Render the element for a section title.
         *
         * @param data - The data to use for rendering the section title.
         *
         * @returns A element representing the section title.
         */
        createSectionTitle(data) {
            const handle = super.createSectionTitle(data);
            handle.classList.add('jp-AccordionPanel-title');
            return handle;
        }
    }
    RTCPanel.Renderer = Renderer;
})(RTCPanel || (RTCPanel = {}));
//# sourceMappingURL=sidepanel.js.map