import { User } from '@jupyterlab/services';
/**
 * Call the API extension
 *
 * @param endPoint API REST end point for the extension
 * @param init Initial values for the request
 * @returns The response body interpreted as JSON
 */
export declare function requestAPI<T>(endPoint?: string, init?: RequestInit): Promise<T>;
/**
 * Global awareness for JupyterLab scopped shared data.
 */
export interface ICollaboratorAwareness {
    /**
     * The User owning theses data.
     */
    user: User.IIdentity;
    /**
     * The current file/context the user is working on.
     */
    current?: string;
}
